<template>
  <v-row justify="center">
    <v-dialog v-model="dialog" width="40em" persistent>
      <v-card>
        <v-card-title variant="elevated" elevation="5" density="compact">Edit user <small>{{ user._id }}</small></v-card-title>
        <v-card-text>
          <v-form v-model="dataCorrect">
            <v-text-field variant="solo" type="text" placeholder="first name..." v-model="user.firstName" :rules="[ onlyLetters ]"/>
            <v-text-field variant="solo" type="text" placeholder="lastname..." v-model="user.lastName" :rules="[ onlyLetters ]"/>
            <v-text-field variant="solo" type="text" placeholder="email..." v-model="user.email" :rules="[ emailValid ]"/>
            <v-text-field variant="solo" type="number" placeholder="pesel..." v-model="user.pesel" :rules="[ peselValid ]"/>
            <v-chip-group v-model="user.roles" multiple selected-class="text-success">
              <v-chip v-for="(roleName, rindex) in ['admin', 'user']" :key="rindex" size="small" variant="tonal">{{ roleName }}</v-chip>
            </v-chip-group>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-btn variant="elevated" color="success" @click="addUser" :disabled="dataCorrect == false" v-if="!user._id">Add</v-btn>
          <v-btn variant="elevated" color="success" @click="updateUser" :disabled="dataCorrect == false" v-if="user._id">Update</v-btn>
          <v-btn variant="elevated" color="error" @click="deleteUser" v-if="user._id">Delete</v-btn>
          <v-btn variant="elevated" @click="close">Cancel</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
  <Confirm @okConfirm="deleteUserReal" @cancelConfirm="confirmDelete = false" title="Confirm deletion" :subtitle="user._id" :show="confirmDelete"/>
  <v-snackbar v-model="error.show" timeout="5000">{{ error.message }}</v-snackbar>
</template>

<script>
import axios from 'axios'

import Confirm from './Confirm.vue'

export default {
  name: 'EditUser',
  inheritAttrs: false,
  components: { Confirm }, 
  props: [ 'show' ],
  emits: [ 'hideEditUser' ],
  methods: {
    close() {
        this.$emit('hideEditUser')
    },
    addUser() {
      let payload = this.user
      axios.post('/user', payload).then(
        (res) => {
           this.$emit('hideEditUser', res.data)
          }
      ).catch(
        (err) => {
          this.error.message = err.response.data.message + ': ' + err.response.data.error
          this.error.show = true
        }
      )
    },
    updateUser() {
      console.log(this.user)
      let payload = this.user
      axios.put('/user', payload).then(
        (res) => {
           this.$emit('hideEditUser', res.data)
          }
      ).catch(
        (err) => {
          this.error.message = err.response.data.message + ': ' + err.response.data.error
          this.error.show = true
        }
      )
    },
    deleteUser() {
      this.confirmDelete = true
    },
    deleteUserReal() {
      this.confirmDelete = false
      axios.delete('/user?_id=' + this.user._id).then(
        (res) => {
           this.$emit('hideEditUser', res.data)
          }
      ).catch(
        (err) => {
          this.error.message = err.response.data.message + ': ' + err.response.data.error
          this.error.show = true
        }
      )
    },
    onlyLetters(v) {
      if(/^[A-Za-z]+$/.test(v)) return true
      return 'Letters only'
    },
    emailValid(v) {
      if (/^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v)) return true
      return "Invalid email"
    },
    peselValid(v) {
      if(v.length != 11) return 'pesel should have 11 digits'
      let weight = [1, 3, 7, 9, 1, 3, 7, 9, 1, 3]
      let sum = 0
      let controlNumber = parseInt(v.substring(10, 11))
      for (let i = 0; i < weight.length; i++) {
          sum += (parseInt(v.substring(i, i + 1)) * weight[i])
      }
      sum = sum % 10
      if((10 - sum) % 10 === controlNumber) return true
      return 'pesel is not valid'
    }
  },
  data() {
    return {
      user: {},
      dataCorrect: true,
      error: { show: false, message: '' },
      confirmDelete: false
    }
  },
  computed: {
    dialog: {
      get() {
        if(typeof this.show == 'object') {
          Object.assign(this.user, this.show)
        } else {
          delete this.user._id
          Object.assign(this.user, {
            firstName: '',
            lastName: '',
            email: '',
            pesel: '',
            roles: []
          })
        }
        return !!this.show
      },
      set() { this.$emit('hideEditUser') }
    }
  },
  mounted() {},
  unmounted() {}
}
</script>

<style scoped>
</style>